#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int index;
    int temp ;
    int DevIndex = 0;
    float Ai[80000];
    //执行库文件内函数进行二次开发  需要最先执行libusb初始化函数
    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 打开设备    默认接一张采集卡 默认索引为0 如接多张采集  则需要获取采集卡SN码函数进行区分
    temp = USB3OpenDevice(DevIndex);
    //获取采集卡SN码  函数返回值代表SN码
    temp = USB3ReadDevcieSN(DevIndex);
    qDebug()<<"集卡SN码:"<< temp;
    // 采集卡默认开启8通道，先进行8通道关闭 ，防止忘记默认开启的通道开启 导致数据混乱
    for(int i = 0; i < 8; i++)
    {
        // 选中第 i 个通道
        temp = SetUSB3AiChanSel(DevIndex, i, 0);
        // 设置第 i 个通道的量程为 ±10.24V
        temp = SetUSB3AiRange(DevIndex, i , 10.24);
    }
    // 选中前 8 个通道，并且分别设置量程。
    for(int i = 0; i < 8; i++)
    {
        // 选中第 i 个通道
        temp = SetUSB3AiChanSel(DevIndex, i, 1);
        // 设置第 i 个通道的量程为 ±10.24V
        temp = SetUSB3AiRange(DevIndex, i , 10.24);
    }
    // 设置为连续采集模式
    temp = SetUSB3AiSampleMode(DevIndex, 0);
    // 设置 Ai 输入的接线方式为 NRSE
    temp = SetUSB3AiConnectType(DevIndex, 1);
    // 设置 Ai 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
    temp = SetUSB3AiSampleRate(DevIndex, 10000);
    // 设置 Ai 触发源为软件触发
    temp = SetUSB3AiTrigSource(DevIndex, 0);
    // 设置 Ai 采样时钟为 Ai 内部采样时钟
    temp = SetUSB3AiConvSource(DevIndex, 0);
    // 清空一次 AiFifo
    temp = SetUSB3ClrAiFifo(DevIndex);
    // 启动一次软件触发
    temp = SetUSB3AiSoftTrig(DevIndex);
    // 开始读取数据。
    // 如果需要长时间连续采集，持续循环使用 USB3GetAi() 函数读取即可。
    // 读取出来的数据是稳定连续采集得到的数据。
    // 此处作为范例，仅连续读取 10 次。如需连续采集 则需要连续不断执行GetAi函数
    // GetAi函数的返回值代表缓冲区剩余数据的个数，采集卡每个模拟量通道缓冲区大小是2百万个数据空间 可通过函数返回值
    // 观察缓冲区数据是否有堆积
    // 超时时间的设定 则是规定GetAi函数在1000ms内需要从缓冲区获取到1000个数据 如果缓冲区内没有1000个数据 则最多等待超时的时间 然后报错误信息- 7
    // 具体函数返回值返回负数的报错信息可以查看官网提供的函数手册
    for(int i = 0; i < 50; i++)
    {
        // 每通道读取 1000 个点存放于 Ai 数组中，超时时间为 1000ms
        // 数据存放规则为前 1000 个数据是 Ai 0 通道；
        //          接下来 1000 个数据是 Ai 1 通道；
        //          接下来 1000 个数据是 Ai 2 通道；
        // 依此类推。
        temp = USB3GetAi(DevIndex, 1000, Ai, 1000);
        //此范例仅打印第一通道每次从缓冲区获取的1000个数据的第一个作为演示
        qDebug()<<"缓冲区剩余数据个数 ："<< temp;
        qDebug()<<Ai[0];

    }
    // 清除 Ai 触发信号
    temp = SetUSB3ClrAiTrigger(DevIndex);
    // 清空 AiFifo
    temp = SetUSB3ClrAiFifo(DevIndex);
    //关闭采集卡
    temp= USB3CloseDevice(DevIndex);
    //关闭采集卡 需要最后执行libusb退出函数
    return 0;
}
