#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

        int temp;
        int i;
        int index;
        int DevIndex = 0;		// 设备索引，默认设备 0
        float Ai[80000];

        index = FindUSB3DAQ();
        qDebug()<<"采集卡数量："<<index;
        // 调用函数时，返回错误代码
        // 打开设备    默认接一张采集卡 默认索引为0 如接多张采集  则需要获取采集卡SN码函数进行区分
        temp = USB3OpenDevice(DevIndex);
        //获取采集卡SN码  函数返回值代表SN码
        temp = USB3ReadDevcieSN(DevIndex);
        qDebug()<<"采集卡SN码"<<temp;
        // 选中前 8 个通道，采集卡默认开启8通道，先提前关闭8通道 防止默认开启的通道导致数据混乱。
        for(i = 0; i < 8; i++)
        {
            // 选中第 i 个通道
            temp = SetUSB3AiChanSel(DevIndex, i, 0);
            // 设置第 i 个通道的量程为 ±10.24V
            temp = SetUSB3AiRange(DevIndex, i , 10.24);
        }
        // 选中前 8 个通道，并且分别设置量程。
        for(i = 0; i < 1; i++)
        {
            // 选中第 i 个通道
            temp = SetUSB3AiChanSel(DevIndex, i, 1);
            // 设置第 i 个通道的量程为 ±10.24V
            temp = SetUSB3AiRange(DevIndex, i , 10.24);
        }
        // 设置为 OneShot 采集模式
        temp = SetUSB3AiSampleMode(DevIndex, 1);
        // 设置 OneShot 采集时，每通道采集 1000 点
        temp = SetUSB3AiOneShotPoints(DevIndex, 1000);
        // 设置 Ai 输入的接线方式为 NRSE
        temp = SetUSB3AiConnectType(DevIndex, 1);
        // 设置 Ai 输入的采样周期为 10000 ns，即 10us，采样率为 100kHz
        temp = SetUSB3AiSampleRate(DevIndex, 10000);
        // 设置 Ai 触发源为软件触发
        temp = SetUSB3AiTrigSource(DevIndex, 0);
        // 设置 Ai 采样时钟为 Ai 内部采样时钟
        temp = SetUSB3AiConvSource(DevIndex, 0);
        // 清空一次 AiFifo
        temp = SetUSB3ClrAiFifo(DevIndex);
        // 启动一次软件触发
        temp = SetUSB3AiSoftTrig(DevIndex);
        // 开始读取数据。oneshot模式下 按照采集到设定的点数后 即停止采集
        // 如果需要长时间连续采集，持续循环使用 USB3GetAi() 函数读取即可。
        // 读取出来的数据是稳定连续采集得到的数据。
        // GetAi函数的返回值代表缓冲区剩余数据的个数，采集卡每个模拟量通道缓冲区大小是2百万个数据空间 可通过函数返回值
        // 观察缓冲区数据是否有堆积
        // 超时时间的设定 则是规定GetAi函数在1000ms内需要从缓冲区获取到1000个数据 如果缓冲区内没有1000个数据 则最多等待超时的时间 然后报错误信息- 7
        // 具体函数返回值返回负数的报错信息可以查看官网提供的函数手册
        // 依此类推。
        temp = USB3GetAi(DevIndex, 1000, Ai, 1000);
        //此范例仅打印第一通道每次从缓冲区获取的1000个数据的第一个作为演示
        qDebug()<<"缓冲区剩余数据个数 ："<<temp;
        qDebug()<<Ai[0];
        // 清除 Ai 触发信号
        temp = SetUSB3ClrAiTrigger(DevIndex);
        // 清空 AiFifo
        temp = SetUSB3ClrAiFifo(DevIndex);
        // 关闭设备
        temp = USB3CloseDevice(DevIndex);

    return 0;
}
