#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
#include <math.h>
#include <QThread>
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i, j;
    int DevIndex = 0;
    unsigned char Chan = 0;
    float waveform[1000];
    int index;
    // 生成一个由 1000 个点组成的正弦波
    for(i = 0; i < 1000; i++)
    {
        waveform[i] = sin(float(((float)i/1000)*2*3.14));
    }

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备    默认接一张采集卡 默认索引为0 如接多张采集  则需要获取采集卡SN码函数进行区分
    temp = USB3OpenDevice(DevIndex);
    // 清除触发标志
    temp = SetUSB3ClrAoTrigger(DevIndex, Chan);
    // 清空 AoFifo
    temp = SetUSB3ClrAoFifo(DevIndex, Chan);
    // 设置为计算机缓冲的连续不循环输出模式
    temp = SetUSB3AoSampleMode(DevIndex, Chan, 0);

    // 设置 Ao 采样周期为 10000ns，即 100kSa/s   即代表10us输出一个数据点
    temp = SetUSB3AoSampleRate(DevIndex, Chan, 10000);
    // 设置触发源为 AoSoftTrig 软件触发
    temp = SetUSB3AoTrigSource(DevIndex, Chan, 0);
    //设置采样时钟源为 Ao 内部采样时钟源，该时采样时钟频率由 SetUSB3AoSampleRate() 函数设定。
    temp = SetUSB3AoConvSource(DevIndex, Chan, 0);
    // 启动软件触发
    temp = SetUSB3AoSoftTrig(DevIndex, Chan);
    // 在此循环中连续不断的发送最新的不循环波形数据到 AoFifo
    // 此处作为例程，只连续发送 100 次
    for(i = 0; i < 100; i++)
    {
        // 将波形数组 waveform 的前 1000 个点下载到 AoFifo 中，
        temp = SetUSB3AoDataFifo(DevIndex, Chan, waveform, 1000);
        qDebug()<< i ;
    }
    //延时1s
    QThread::msleep(1000);
    // 清除所有触发标志
    temp = SetUSB3ClrTrigger(DevIndex);
    // 关闭设备
    temp = USB3CloseDevice(DevIndex);


    return 0;
}
