#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
#include <math.h>
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;
    unsigned char Chan = 0;
    float waveform[1000];
    int index;
    // 生成一个由 1000 个点组成的正弦波
    for(i = 0; i < 1000; i++)
    {
        waveform[i] = sin(float(((float)i/1000)*2*3.14));
    }

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备    默认接一张采集卡 默认索引为0 如接多张采集  则需要获取采集卡SN码函数进行区分
    temp = USB3OpenDevice(DevIndex);

    // 分别对 4 个通道进行设置
    for(Chan = 0; Chan < 4; Chan++)
    {
        // 清除触发标志
        temp = SetUSB3ClrAoTrigger(DevIndex, Chan);

        // 清空 AoFifo
        temp = SetUSB3ClrAoFifo(DevIndex, Chan);

        // 设置为 NCycle 模式，代表硬件 Fifo 缓冲的有限次数/无限循环输出模式，其循环次数由 SetUSB3AoCycle() 函数决定。
        temp = SetUSB3AoSampleMode(DevIndex, Chan, 1);

        // 设置 Ao 采样周期为 10000ns，即 100kSa/s
        temp = SetUSB3AoSampleRate(DevIndex, Chan, 10000);

        // 设置触发源为 GlobalSoftTrig 全局软件触发
        temp = SetUSB3AoTrigSource(DevIndex, Chan, 255);

        //设置采样时钟源为 Ao 内部采样时钟源，该时采样时钟频率由 SetUSB3AoSampleRate() 函数设定。
        temp = SetUSB3AoConvSource(DevIndex, Chan, 0);

        // 设置无限循环输出，AoCycle 参数设置为 0 即可。
        temp = SetUSB3AoCycle(DevIndex, Chan, 0);

        // 将波形数组 waveform 的前 500 个点下载到 AoFifo 中，
        temp = SetUSB3AoDataFifo(DevIndex, Chan, waveform, 1000);
    }

    // 选择需要通道的 ao 通道。
    // 0xf 参数的 bit-0 到 bit 3 对应 ao 0 到 ao 3。
    // 例如，如果只选择 ai 0 和 ai 1，此参数应设置为 0x03。
    // 依次类推。
    temp = SetUSB3AoSync(DevIndex, 0x0f);
    // 启动全局软件触发
    temp = SetUSB3GlobalSoftTrig(DevIndex);
    qDebug()<<"触发完成";
    // 关闭设备
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
