#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;		// 设备索引，默认设备 0
    unsigned int CtValue_0[1000];
    unsigned int CtValue_1[1000];
    unsigned int CtValue_2[1000];
    int index;

    // 调用函数时，返回错误代码
    // 打开设备
    temp = USB3OpenDevice(DevIndex);
    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    //开始设置3个通道的计数器，都设置为边沿计数模式
    for (i = 0; i < 3; i++)
    {
        //设置计数运行模式为边沿计数模式
        temp = SetCtRunMode(DevIndex, i, 0);

        //设置采样模式为采样时钟缓冲的的连续采集
        temp = SetCtSampleMode(DevIndex, i, 1);

        //设置采样时钟为内部采样时钟
        temp = SetCtConvSource(DevIndex, i, 0);

        //选择计数器的Src信号源为外部Src
        temp = SetCtSrcSel(DevIndex, i, 1);

        //设置计数边沿为上升沿
        temp = SetCtCountEdge(DevIndex, i, 1);

        //设置采样时钟为 10kHz，即采样周期为 100000ns
        temp = SetCtSampleRate(DevIndex, i, 100000);

        //设置计数器的触发源为软件触发
        temp = SetCtTrigSource(DevIndex, i, 0);

        //设置计数器的初始值
        temp = SetCtValue(DevIndex, i, 0);

        //设置计数器溢出值
        temp = SetCtOverflowValueEdgeCount(DevIndex, i, 10000);

        //设置计数器溢出后的默认值
        temp = SetCtReloadValueEdgeCount(DevIndex, i, 0);

        //设置计数器计数方向，此处设置递增
        temp = SetCtDirEdgeCount(DevIndex, i, 1);

        //清空计数器fifo
        temp = SetCtClrFifo(DevIndex, i);
    }

     //启动3个计数器
    for (i = 0; i < 3; i++)
    {
        temp = SetCtSoftTrig(DevIndex, i);
    }

    // 开始读取数据。
    // 如果需要长时间连续采集，持续循环使用 USB3GetCt() 函数读取即可。
    // 读取出来的数据是稳定连续采集得到的数据。
    // 此处作为范例，仅连续读取 10 次。
    for(i = 0; i < 10; i++)
    {
        // 读取计数器 0
        temp = USB3GetCt(DevIndex, 0, 1000, CtValue_0, 1000);
        // 读取计数器 1
        temp = USB3GetCt(DevIndex, 1, 1000, CtValue_1, 1000);
        // 读取计数器 2
        temp = USB3GetCt(DevIndex, 2, 1000, CtValue_2, 1000);

        //范例仅显示第一个计数通道每次获取的第1000个数据作为显示为例
        qDebug()<<"计数值："<<CtValue_0[999];

    }

    // 退出程序时，关闭触发，关闭设备
    temp = SetUSB3ClrTrigger(DevIndex);
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
