#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
#include <QThread>
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;		// 设备索引，默认设备 0
    unsigned int CtValue_0[1000];
    unsigned int CtValue_1[1000];
    unsigned int CtValue_2[1000];
    unsigned long CtULong_0;
    double CtDouble_0;
    int index;

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备
    temp = USB3OpenDevice(DevIndex);

    //开始设置3个通道的计数器，都设置为频率测试模式
    for (i = 0; i < 3; i++)
    {
        //设置计数运行模式为频率测量模式
        temp = SetCtRunMode(DevIndex, i, 4);

        //设置采样模式为采样时钟缓冲的的连续采集
        temp = SetCtSampleMode(DevIndex, i, 1);

        //设置采样时钟为内部采样时钟
        temp = SetCtConvSource(DevIndex, i, 0);

        //设置采样时钟为 10kHz，即采样周期为 100000ns
        temp = SetCtSampleRate(DevIndex, i, 100000);

        //选择计数器的Src信号源为内部Src
        temp = SetCtSrcSel(DevIndex, i, 0);

        //设置计数器的内部Src周期为 10ns
        temp = SetCtInternalSrcPeriod(DevIndex, i, 10);

        //设置计数器的触发源为软件触发
        temp = SetCtTrigSource(DevIndex, i, 0);

        //清空计数器fifo
        temp = SetCtClrFifo(DevIndex, i);
    }

    //启动3个计数器
    for (i = 0; i < 3; i++)
    {
        temp = SetCtSoftTrig(DevIndex, i);
    }

    // 为方便演示，延时1s，等待计数器完成测量
    //延时1秒
    QThread::msleep(1000);

    // 开始读取数据。
    // 如果需要长时间连续采集，持续循环使用 USB3GetCt() 函数读取即可。
    // 读取出来的数据是稳定连续采集得到的数据。
    // 此处作为范例，仅连续读取 10 次。
    for(i = 0; i < 10; i++)
    {
        // 读取计数器 0
        temp = USB3GetCt(DevIndex, 0, 1000, CtValue_0, 1000);
        // 读取计数器 1
        temp = USB3GetCt(DevIndex, 1, 1000, CtValue_1, 1000);
        // 读取计数器 2
        temp = USB3GetCt(DevIndex, 2, 1000, CtValue_2, 1000);
        // 把计数器值换算成频率
        //乘以内部Src周期 10ns，得到周期
        CtULong_0 = CtValue_0[999] * 10;

        //得到频率，单位 kHz
        if(CtULong_0 > 0)
        {
            CtDouble_0 = (1 / (double)CtULong_0) * 1000000;
            qDebug()<<" 周期以khz为单位:"<<CtDouble_0;

        }

    }



    // 退出程序时，关闭触发，关闭设备
    temp = SetUSB3ClrTrigger(DevIndex);
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
