#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;		// 设备索引，默认设备 0
    unsigned int CtValue_0[1000];
    unsigned int CtValue_1[1000];
    unsigned int CtValue_2[1000];
    int index;

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备
    temp = USB3OpenDevice(DevIndex);

    // 分别对3个计数器通道进行设置
    for(i = 0; i < 3; i++)
    {
        // 设置计数器工作模式为正交编码器测量
        temp = SetCtRunMode(DevIndex, i, 5);

        // 设置采样方式为采样时钟缓冲连续采集
        temp = SetCtSampleMode(DevIndex, i, 1);

        // 设置计数器采样时钟为内部采样时钟
        temp = SetCtConvSource(DevIndex, i, 0);

        // 设置计数器采样周期为 100000ns，即采样率为10k/s
        temp = SetCtSampleRate(DevIndex, i, 100000);

        // 设置计数器触发源为软件触发
        temp = SetCtTrigSource(DevIndex, i, 0);

        // 设置编码器类型为正交编码器，X1
        // 0: 正交编码器，X1
        // 1: 正交编码器，X2
        // 2: 正交编码器，X4
        // 3: 双脉冲编码器
        temp = SetCtEncoderMode(DevIndex, i, 0);

        // 设置Z索引的启动条件
        // 如果没有Z索引功能，不调用此函数
        temp = SetCtZPhase(DevIndex, i, 0, 0);

        // 设置Z索引启动后，初始化的测量值为0
        // 如果没有Z索引功能，不调用此函数
        temp = SetCtZValue(DevIndex, i, 0);

        // 设置Z索引使能
        // 如果没有Z索引功能，不调用此函数
        temp = SetCtZEnable(DevIndex, i, 1);

        // 清空计数器fifo
        temp = SetCtClrFifo(DevIndex, i);
    }

    // 分别启动3个计数器
    for(i = 0; i < 3; i++)
    {
        temp = SetCtSoftTrig(DevIndex, i);
    }

    // 开始读取数据。
    // 如果需要长时间连续采集，持续循环使用 USB3GetCt() 函数读取即可。
    // 读取出来的数据是稳定连续采集得到的数据。
    // 此处作为范例，仅连续读取 10 次。
    for(i = 0; i < 10; i++)
    {
        // 读取计数器 0
        temp = USB3GetCt(DevIndex, 0, 1000, CtValue_0, 1000);
        // 读取计数器 1
        temp = USB3GetCt(DevIndex, 1, 1000, CtValue_1, 1000);
        // 读取计数器 2
        temp = USB3GetCt(DevIndex, 2, 1000, CtValue_2, 1000);
        //每次对应通道的数组里面的数据 代表连续不断采集的编码器计数值
        // 需要将数组内数据转为int类型数据 即代表正向与反向的计数值
    }

    // 退出程序时，关闭触发，关闭设备
    temp = SetUSB3ClrTrigger(DevIndex);
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
