#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
#include <QThread>
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;		// 设备索引，默认设备 0
    unsigned int CtValue_0[2000];
    unsigned int CtValue_1[2000];
    unsigned int CtValue_2[2000];
    unsigned int Ct0_Pos;
    unsigned int Ct0_Neg;
    unsigned int Ct1_Pos;
    unsigned int Ct1_Neg;
    unsigned int Ct2_Pos;
    unsigned int Ct2_Neg;
    int index;

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备
    temp = USB3OpenDevice(DevIndex);

    //开始设置3个通道的计数器，都设置为脉冲测量模式
    for (i = 0; i < 3; i++)
    {
        //设置计数运行模式为脉冲测量模式
        temp = SetCtRunMode(DevIndex, i, 2);

        //设置采样模式为采样时钟缓冲连续采集
        temp = SetCtSampleMode(DevIndex, i, 1);

        // 设置采样时钟源为内部时钟源
        temp = SetCtConvSource(DevIndex, i, 0);

        // 设置计数器采样周期为 100000ns，即采样率为10k/s
        temp = SetCtSampleRate(DevIndex, i, 100000);

        //选择计数器的Src信号源为内部Src
        temp = SetCtSrcSel(DevIndex, i, 0);

        //设置计数器的内部Src周期为 100ns
        temp = SetCtInternalSrcPeriod(DevIndex, i, 100);

        //设置计数器的触发源为软件触发
        temp = SetCtTrigSource(DevIndex, i, 0);

        // 清空计数器fifo
        temp = SetCtClrFifo(DevIndex, i);
    }

    //启动3个计数器
    for (i = 0; i < 3; i++)
    {
        temp = SetCtSoftTrig(DevIndex, i);
    }

    // 为方便演示，延时1s，等待计数器完成测量
    //延时1秒
    QThread::msleep(1000);

    // 开始读取数据。
    // 如果需要长时间连续采集，持续循环使用 USB3GetCt() 函数读取即可。
    // 读取出来的数据是稳定连续采集得到的数据。
    // 此处作为范例，仅连续读取 10 次。
    for(i = 0; i < 10; i++)
    {
        // 读取计数器 0
        temp = USB3GetCt(DevIndex, 0, 2000, CtValue_0, 1000);
        // 读取计数器 1
        temp = USB3GetCt(DevIndex, 1, 2000, CtValue_1, 1000);
        // 读取计数器 2
        temp = USB3GetCt(DevIndex, 2, 2000, CtValue_2, 1000);
    }
    //高电平测量值存放于结果的高 16-bit，低电平测量值存放于结果的低 16-bit
    // 把计数器值最新的一个值换算成正脉宽和负脉宽的值
    Ct0_Pos = (CtValue_0[1999] >> 16);
    Ct0_Neg = (CtValue_0[1999] << 16) >> 16;
    Ct1_Pos = (CtValue_1[1999] >> 16);
    Ct1_Neg = (CtValue_1[1999] << 16) >> 16;
    Ct2_Pos = (CtValue_2[1999] >> 16);
    Ct2_Neg = (CtValue_2[1999] << 16) >> 16;

    // 把数据单位转换成 ns，乘以 100ns
    Ct0_Pos = Ct0_Pos * 100;
    Ct0_Neg = Ct0_Neg * 100;
    Ct1_Pos = Ct1_Pos * 100;
    Ct1_Neg = Ct1_Neg * 100;
    Ct2_Pos = Ct2_Pos * 100;
    Ct2_Neg = Ct2_Neg * 100;
    qDebug()<<"通道0正脉宽_单位ns："<<Ct0_Pos;
    qDebug()<<"通道0负脉宽_单位ns："<<Ct0_Neg;
    // 退出程序时，关闭触发，关闭设备
    temp = SetUSB3ClrTrigger(DevIndex);
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
