#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
#include <QThread>
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;		// 设备索引，默认设备 0
    unsigned int CtValue_0[2000];
    unsigned int CtValue_1[2000];
    unsigned int CtValue_2[2000];
    unsigned int ct0;
    unsigned int ct1;
    unsigned int ct2;
    int index;
    //执行库文件内函数进行二次开发  需要最先执行libusb初始化函数

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备
    temp = USB3OpenDevice(DevIndex);
    //范例以正脉宽为例子
    //开始设置3个通道的计数器，都设置为脉宽测量模式
    for (i = 0; i < 3; i++)
    {
        //设置计数运行模式为脉宽测量模式
        temp = SetCtRunMode(DevIndex, i, 1);

        // 设置测量起始边沿为上升沿，即测量正脉宽
        // 如果设置测量起始边沿为下降沿，则测量的是负脉宽
        temp = SetCtPulseWidthStartEdge(DevIndex, i, 1);

        //设置采样模式为采样时钟缓冲连续采集
        temp = SetCtSampleMode(DevIndex, i, 1);

        // 设置采样时钟源为内部时钟源
        temp = SetCtConvSource(DevIndex, i, 0);

        // 设置计数器采样周期为 100000ns，即采样率为10k/s
        temp = SetCtSampleRate(DevIndex, i, 100000);

        //选择计数器的Src信号源为内部Src
        temp = SetCtSrcSel(DevIndex, i, 0);

        //设置计数器的内部Src周期为 10ns
        temp = SetCtInternalSrcPeriod(DevIndex, i, 100);

        //设置计数器的触发源为软件触发
        temp = SetCtTrigSource(DevIndex, i, 0);

        // 清空计数器fifo
        temp = SetCtClrFifo(DevIndex, i);
    }

    //启动3个计数器
    for (i = 0; i < 3; i++)
    {
        temp = SetCtSoftTrig(DevIndex, i);
    }

    // 为方便演示，延时1s，等待计数器完成测量
    //延时1秒
    QThread::msleep(1000);

    // 开始读取数据。
    // 如果需要长时间连续采集，持续循环使用 USB3GetCt() 函数读取即可。
    // 读取出来的数据是稳定连续采集得到的数据。
    // 此处作为范例，仅连续读取 10 次。
    for(i = 0; i < 10; i++)
    {
        // 读取计数器 0
        temp = USB3GetCt(DevIndex, 0, 2000, CtValue_0, 1000);
        // 读取计数器 1
        temp = USB3GetCt(DevIndex, 1, 2000, CtValue_1, 1000);
        // 读取计数器 2
        temp = USB3GetCt(DevIndex, 2, 2000, CtValue_2, 1000);
    }

    // 把计数器值最新的一个值换算成脉宽值
    // 把数据单位转换成 ns，乘以 100ns
    ct0 = CtValue_0[1999] * 100;
    ct1 = CtValue_1[1999] * 100;
    ct2 = CtValue_2[1999] * 100;

    qDebug()<<"正脉宽_单位ns"<<ct0;
    // 退出程序时，关闭触发，关闭设备
    temp = SetUSB3ClrTrigger(DevIndex);
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
