#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;		// 设备索引，默认设备 0
    int index;
    unsigned char Di[80000];

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备    默认接一张采集卡 默认索引为0 如接多张采集  则需要获取采集卡SN码函数进行区分
    temp = USB3OpenDevice(DevIndex);
    temp = USB3ReadDevcieSN(DevIndex);
    // 设置 Conv Out 端口输出信号源为数字输入采样时钟。如果不使用该信号，可不设置。
    temp = SetUSB3ExtConvOutSource(DevIndex, 3);
    // 设置 Ext Trig Out 端口输出信号源为数字输入触发信号。如果不使用该信号，可不设置。
    temp = SetUSB3ExtTrigOutSource(DevIndex, 1);
    // 设置为连续采集模式
    temp = SetUSB3DiSampleMode(DevIndex, 0);
    // 设置模拟输入采集使用 DiSoftTrig 软件触发
    temp = SetUSB3DiTrigSource(DevIndex, 0);
    // 设置模拟输入采样时钟源为 Di 内部采样时钟源。该时钟源频率由 SetUSB3DiSampleRate() 函数设定。
    temp = SetUSB3DiConvSource(DevIndex, 0);
    // 设置采样周期为 100000ns，即 10kSa/s/Ch
    temp = SetUSB3DiSampleRate(DevIndex, 100000);
    // 设置 Di 预触发点数为 0
    temp = SetUSB3DiPreTrigPoints(DevIndex, 0);
    // 清空 DiFifo
    temp = SetUSB3ClrDiFifo(DevIndex);
    // 启动 DiSoftTrig 软件触发
    temp = SetUSB3DiSoftTrig(DevIndex);
    // 开始读取数据。
    // 如果需要长时间连续采集，持续循环使用 USB3GetDi() 函数读取即可。
    // 读取出来的数据是稳定连续采集得到的数据。
    // 此处作为范例，仅连续读取 10 次。
    for(i = 0; i < 10; i++)
    {
        // 每通道读取 10000 个点存放于 Di 数组中，超时时间为 1000ms
        // 每一个 Di 数据的  bit-0 代表 Di 0 通道；    0为低电平 1为高电平
        //                 bit-1 代表 Di 1 通道。
        //                 bit-2 代表 Di 2 通道；
        //                 bit-3 代表 Di 3 通道。以此类推
        temp = USB3GetDi(DevIndex, 1000, Di, 1000);
        qDebug()<<"缓冲区剩余数据："<<temp;
        //打印di通道数据 每个数据都代表采集卡所有通道的信息  默认采集卡Di通道为高电平 每一bit都为1    8通道悬空值255  4通道悬空值15
        qDebug()<<Di[0];

    }
    // 清除 Di 触发信号
    temp = SetUSB3ClrDiTrigger(DevIndex);
    // 清空 AiFifo
    temp = SetUSB3ClrDiFifo(DevIndex);
    // 关闭设备
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
