#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i;
    int DevIndex = 0;
    unsigned int waveform[10] = {255,0,255,0,255,0,255,0,255,0};
    int index;

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备    默认接一张采集卡 默认索引为0 如接多张采集  则需要获取采集卡SN码函数进行区分
    temp = USB3OpenDevice(DevIndex);

    // 选择需要通道的 Do 通道。
    // 0x3 参数的 bit-0 对应 Do 0；bit-1 对应 Do 1
    // 例如，如果只选择 Do 0，此参数应设置为 0x01。
    //       如果只选择 Do 1，此参数应设置为 0x02。
    //       如果只选择 Do 2，此参数应设置为 0x04。
    // 此范例以8通道Do功能采集卡为例
    temp = SetUSB3DoWaveCtrl(DevIndex, 0xFF);
    // 清除 Do 触发标志
    temp = SetUSB3ClrDoTrigger(DevIndex);
    // 清空 DoFifo
    temp = SetUSB3ClrDoFifo(DevIndex);
    // 设置 Do 采样周期为 10000ns，即 100kSa/s
    temp = SetUSB3DoSampleRate(DevIndex, 10000);
    // 设置为硬件 Fifo 缓冲的有限次数/无限循环输出模式 ，其循环次数由SetUSB3DoCycle() 函数决定 。
    temp = SetUSB3DoSampleMode(DevIndex, 1);
    // 设置触发源为 DoSoftTrig 软件触发
    temp = SetUSB3DoTrigSource(DevIndex, 0);
    // 设置 Do 采样时钟为 Do 内部采样时钟源，该时采样时钟频率由 SetUSB3DoSampleRate() 函数设定。
    temp = SetUSB3DoConvSource(DevIndex, 0);
    // 设置输出波形 。无限循环一直输出，DoCycle 参数设置为 0 即可。 如需按照次数输出 更改DoCycle函数参数即可
    temp = SetUSB3DoCycle(DevIndex, 0);
    // 将波形数组 waveform 的前 10 个点下载到 DoFifo 中
    temp = SetUSB3DoDataFifo(DevIndex, waveform, 10);
    // 启动 DoSoftTrig 软件触发
    temp = SetUSB3DoSoftTrig(DevIndex);
    // 关闭设备
    temp = USB3CloseDevice(DevIndex);


    return 0;
}
