#include <QCoreApplication>
#include <QDebug>
extern"C"{
#include "USB3000.h"
}
#include <QThread>
int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    int temp;
    int i, j;
    int DevIndex = 0;
    unsigned int waveform[1000];
    int index;
    //初始化一个1000点数据的波形
    for(int i = 0; i < 1000 ; i++)
    {
        if(i%2 == 0)
        {
            waveform[i] = 255;
        }
        else
        {
            waveform[i] = 0;
        }
    }

    index = FindUSB3DAQ();
    qDebug()<<"采集卡数量："<<index;
    // 调用函数时，返回错误代码
    // 打开设备    默认接一张采集卡 默认索引为0 如接多张采集  则需要获取采集卡SN码函数进行区分
    temp = USB3OpenDevice(DevIndex);

    temp = USB3ReadDevcieSN(DevIndex);
    qDebug()<<"采集卡SN码："<<temp;
    // 选择需要通道的 Do 通道。
    // 0x3 参数的 bit-0 对应 Do 0；bit-1 对应 Do 1
    // 例如，如果只选择 Do 0，此参数应设置为 0x01。
    //       如果只选择 Do 1，此参数应设置为 0x02。
    //       如果只选择 Do 2，此参数应设置为 0x04。
    //       如果只选择 Do 3，此参数应设置为 0x08。
    // 此范例以8通道采集卡Do为例
    temp = SetUSB3DoWaveCtrl(DevIndex, 0xFF);
    // 清除 Do 触发标志
    temp = SetUSB3ClrDoTrigger(DevIndex);
    // 清空 DoFifo
    temp = SetUSB3ClrDoFifo(DevIndex);
    // 设置 Do 采样周期为 10000ns，即 100kSa/s
    temp = SetUSB3DoSampleRate(DevIndex, 10000);
    // 设置为计算机缓冲的连续不循环输出模式
    temp = SetUSB3DoSampleMode(DevIndex, 0);
    // 设置触发源为 DoSoftTrig 软件触发
    temp = SetUSB3DoTrigSource(DevIndex, 0);
    // 设置 Do 采样时钟为 Do 内部采样时钟源，该时采样时钟频率由 SetUSB3DoSampleRate() 函数设定。
    temp = SetUSB3DoConvSource(DevIndex, 0);
    // 启动 DoSoftTrig 软件触发
    temp = SetUSB3DoSoftTrig(DevIndex);
    // 在此循环中连续不断的发送最新的不循环波形数据到 DoFifo
    // 此处作为例程，只连续发送 100 次
    for(i = 0; i < 100; i++)
    {

        // 将波形数组 waveform 的1000 个点下载到 DoFifo 中
        temp = SetUSB3DoDataFifo(DevIndex, waveform, 1000);
        qDebug()<< i ;
    }
    //延时1秒
    QThread::msleep(1000);
    // 清除 Do 触发标志
    temp = SetUSB3ClrDoTrigger(DevIndex);
    // 关闭设备
    temp = USB3CloseDevice(DevIndex);

    return 0;
}
